using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserOrder;
namespace CMSMicroservice.Protobuf.Validator.UserOrder;

public class GetUserOrderRequestValidator : AbstractValidator<GetUserOrderRequest>
{
    public GetUserOrderRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetUserOrderRequest>.CreateWithOptions((GetUserOrderRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
